package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.UserGoodsInMerchantService;
import com.gxwebsoft.shop.entity.UserGoodsInMerchant;
import com.gxwebsoft.shop.param.UserGoodsInMerchantParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 用户在商家中的代金券控制器
 *
 * @author 科技小王子
 * @since 2024-11-20 01:55:04
 */
@Api(tags = "用户在商家中的代金券管理")
@RestController
@RequestMapping("/api/shop/user-goods-in-merchant")
public class UserGoodsInMerchantController extends BaseController {
    @Resource
    private UserGoodsInMerchantService userGoodsInMerchantService;

    @ApiOperation("分页查询用户在商家中的代金券")
    @GetMapping("/page")
    public ApiResult<PageResult<UserGoodsInMerchant>> page(UserGoodsInMerchantParam param) {
        // 使用关联查询
        return success(userGoodsInMerchantService.pageRel(param));
    }

    @ApiOperation("查询全部用户在商家中的代金券")
    @GetMapping()
    public ApiResult<List<UserGoodsInMerchant>> list(UserGoodsInMerchantParam param) {
        // 使用关联查询
        return success(userGoodsInMerchantService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:userGoodsInMerchant:list')")
    @ApiOperation("根据id查询用户在商家中的代金券")
    @GetMapping("/{id}")
    public ApiResult<UserGoodsInMerchant> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(userGoodsInMerchantService.getByIdRel(id));
    }

    @ApiOperation("添加用户在商家中的代金券")
    @PostMapping()
    public ApiResult<?> save(@RequestBody UserGoodsInMerchant userGoodsInMerchant) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
         userGoodsInMerchant.setUserId(loginUser.getUserId());
        }
        if (userGoodsInMerchantService.save(userGoodsInMerchant)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改用户在商家中的代金券")
    @PutMapping()
    public ApiResult<?> update(@RequestBody UserGoodsInMerchant userGoodsInMerchant) {
        if (userGoodsInMerchantService.updateById(userGoodsInMerchant)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除用户在商家中的代金券")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (userGoodsInMerchantService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加用户在商家中的代金券")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<UserGoodsInMerchant> list) {
        if (userGoodsInMerchantService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改用户在商家中的代金券")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<UserGoodsInMerchant> batchParam) {
        if (batchParam.update(userGoodsInMerchantService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除用户在商家中的代金券")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (userGoodsInMerchantService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
